#
# Copyright (c) 2008-2015 Thierry Florac <tflorac AT ulthar.net>
# All Rights Reserved.
#
# This software is subject to the provisions of the Zope Public License,
# Version 2.1 (ZPL).  A copy of the ZPL should accompany this distribution.
# THIS SOFTWARE IS PROVIDED "AS IS" AND ANY AND ALL EXPRESS OR IMPLIED
# WARRANTIES ARE DISCLAIMED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF TITLE, MERCHANTABILITY, AGAINST INFRINGEMENT, AND FITNESS
# FOR A PARTICULAR PURPOSE.
#

__docformat__ = 'restructuredtext'


# import standard library

# import interfaces
from pyams_content.features.preview.zmi.interfaces import IPreviewForm
from pyams_content.shared.view.interfaces import IWfView
from pyams_form.interfaces.form import IWidgetsSuffixViewletsManager
from pyams_skin.layer import IPyAMSLayer
from pyams_utils.interfaces import VIEW_SYSTEM_PERMISSION

# import packages
from pyams_template.template import template_config
from pyams_viewlet.viewlet import viewlet_config


@viewlet_config(name='view-preview', context=IWfView, layer=IPyAMSLayer,
                view=IPreviewForm, manager=IWidgetsSuffixViewletsManager,
                permission=VIEW_SYSTEM_PERMISSION, weight=100)
@template_config(template='templates/preview.pt', layer=IPyAMSLayer)
class SharedViewPreview(object):
    """Shared view preview"""

    @property
    def items(self):
        return self.context.get_results(self.context)
